using System;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Media.Animation;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ž ȯ 
        /// </summary>
        private NavigationTransitionInfo navigationTransitionInfo = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.defaultTransitionRadioButton.Checked        += transitionRadioButton_Checked;
            this.entranceTransitionRadioButton.Checked       += transitionRadioButton_Checked;
            this.drillTransitionRadioButton.Checked          += transitionRadioButton_Checked;
            this.suppressTransitionRadioButton.Checked       += transitionRadioButton_Checked;
            this.slideFromRightTransitionRadioButton.Checked += transitionRadioButton_Checked;
            this.slideFromLeftTransitionRadioButton.Checked  += transitionRadioButton_Checked;
            this.navigateForwardButton.Click                 += navigateForwardButton_Click;
            this.navigateBackwardButton.Click                += navigateBackwardButton_Click;

            this.defaultTransitionRadioButton.IsChecked = true;

            this.frame.Navigate(typeof(SamplePage1));
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ȯ  ư üũ óϱ - transitionRadioButton_Checked(sender, e)

        /// <summary>
        /// ȯ  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void transitionRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            string transitionString = (sender as RadioButton).Content.ToString();

            if(transitionString != "Default")
            {
                if(transitionString == "Entrance")
                {
                    this.navigationTransitionInfo = new EntranceNavigationTransitionInfo();
                }
                else if(transitionString == "DrillIn")
                {
                    this.navigationTransitionInfo = new DrillInNavigationTransitionInfo();
                }
                else if(transitionString == "Suppress")
                {
                    this.navigationTransitionInfo = new SuppressNavigationTransitionInfo();
                }
                else if(transitionString == "Slide from Right")
                {
                    this.navigationTransitionInfo = new SlideNavigationTransitionInfo()
                    {
                        Effect = SlideNavigationTransitionEffect.FromRight
                    };
                }
                else if(transitionString == "Slide from Left")
                {
                    this.navigationTransitionInfo = new SlideNavigationTransitionInfo()
                    {
                        Effect = SlideNavigationTransitionEffect.FromLeft
                    };
                }
            }
            else
            {
                this.navigationTransitionInfo = null;
            }
        }

        #endregion
        #region Navigate Forward ư Ŭ óϱ - navigateForwardButton_Click(sender, e)

        /// <summary>
        /// Navigate Forward ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void navigateForwardButton_Click(object sender, RoutedEventArgs e)
        {
            Type pageType = this.frame.BackStackDepth % 2 == 1 ? typeof(SamplePage1) : typeof(SamplePage2);

            if(this.navigationTransitionInfo == null)
            {
                this.frame.Navigate(pageType, null);
            }
            else
            {
                this.frame.Navigate(pageType, null, this.navigationTransitionInfo);
            }
        }

        #endregion
        #region Navigate Backward ư Ŭ óϱ - navigateBackwardButton_Click(sender, e)

        /// <summary>
        /// Navigate Backward ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void navigateBackwardButton_Click(object sender, RoutedEventArgs e)
        {
            if(this.frame.BackStackDepth > 0)
            {
                this.frame.GoBack();
            }
        }

        #endregion
    }
}